#include<bits/stdc++.h>
using namespace std;
int n,m,q;
unsigned long long br,br1;
int main(){
    cin>>n>>m;
    long long x[n+5][m+5];
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            cin>>x[i][j];
        }
    }
    cin>>q;
    int a[q+5],b[q+5];
    for(int k=1;k<=q;k++){
        cin>>a[k]>>b[k];
    }
    br1=100000000005;
    for(int h=1;h<=n+m-1;h++){
    br=0;
    for(int j=1;j<=m;j++){
        br+=x[1][j];
    }
    for(int i=2;i<=n;i++){
        br+=x[i][m-h+1];
    }
    br1=min(br1,br);
    }
    cout<<br1<<endl;
return 0;
}